#Code written by Andrea Nova. University of Pavia.

STANdatapreparation <- function (data, FamilyID,prevalence,number_covariates, covariates, Proband, Disease)
{
  
  
  #Number of Subjects
  N<<-nrow(data)
  
  #Number of families
  nfam<<-length(unique(data[,as.character(FamilyID)]))
  
  #Sequence number of families
  fam<<-seq(1,nfam)
  
  #Save in "ni" the number of individuals within families and "firstfam" the row number for the first individual within each family
  families<-data[,as.character(FamilyID)]
  families<-families[!duplicated(families)]
  i<-1
  ni<-NULL
  firstfam=NULL
  while(i<nfam+1){
    famm <- which(data[,as.character(FamilyID)]==families[i])
    ni[i] <- length(famm)
    firstfam[i]<-famm[1]
    i<-i+1}
  
  ni<<-ni
  firstfam<<-firstfam

  #Liability threshold
  threshold <<- qnorm(prevalence,0,1,lower.tail=F)
  
  #Create indexes for cases and controls, and lower/upper bounds for the multivariate normal distribution
  k <- which(data[,as.character(Disease)]==1) # Cases. 
  kk <- which(data[,as.character(Disease)]==0) # Controls.
  lb <- rep(-Inf,nrow(data))
  lb_ind <- rep(0,nrow(data))
  lb[k] <- threshold
  lb_ind[k] <- 1
  ub <- rep(Inf,nrow(data))
  ub_ind <- rep(0,nrow(data))
  ub[kk] <- threshold
  ub_ind[kk] <- 1
  
  lb<<-lb
  ub<<-ub
  lb_ind<<-lb_ind
  ub_ind<<-ub_ind
  
  NCOV<<-number_covariates
  
  if(NCOV>0){
  ################IF YOU HAVE COVARIATES
  #Number of covariates

  
  #Build matrix with standardized covariates (if you want to include thse)
  X<<-as.matrix(data[c(as.character(covariates))])
  
  #Covariates standard deviations. Needed to obtain unstandardized fixed effects.
 SD<-NULL
   for(i in 1:NCOV){
    sd1<-sd(X[,i])
    SD<<-c(SD,sd1)
  }

  #Probands covariate values. Change "Proband" with your variable name.
  XP<<-as.matrix(X[which(data[c(as.character(Proband))]==1),])
  
  #Probands disease status.
  YP<<-data[which(data$Proband==1),as.character(Disease)]
  ################
  }
  else{
  ################ IF YOU DON'T HAVE COVARIATES
  X<<-as.matrix(rep(0,nrow(data)))
  #################
  }
}