functions {
real partial_sum(int[] fam_slice,
                   int start, int end,
                 matrix X, matrix XP,vector YP, int[] ni, int[] firstfam, vector lb, vector ub, vector lb_ind, vector ub_ind, vector u, int NFAM, real heritability, real sharedenvironment_sibs,real sharedenvironment_mother, real sharedenvironment_father,real sharedenvironment_spouses, real individualenvironment, matrix kinship_matrix,matrix sharedenvironment_matrix_sibs,matrix sharedenvironment_matrix_mother, matrix sharedenvironment_matrix_father, matrix sharedenvironment_matrix_spouses,matrix identity_matrix, vector betapam,int NCOV, real threshold) {

real lik=0;
 for (k in start:end) {
int nik =ni[k];
int firstfamk =firstfam[k];
row_vector[NCOV] XPk =XP[k,];
real YPk =YP[k];

matrix [nik,nik] Sigmakc=cholesky_decompose(block(kinship_matrix, firstfamk, firstfamk, nik, nik)*heritability + block(sharedenvironment_matrix_sibs, firstfamk, firstfamk, nik, nik)*sharedenvironment_sibs+ block(sharedenvironment_matrix_mother, firstfamk, firstfamk, nik, nik)*sharedenvironment_mother  +block(sharedenvironment_matrix_father, firstfamk, firstfamk, nik, nik)*sharedenvironment_father+block(sharedenvironment_matrix_spouses, firstfamk, firstfamk, nik, nik)*sharedenvironment_spouses+  block(identity_matrix, firstfamk, firstfamk, nik, nik)*(individualenvironment));

matrix[nik,NCOV] Xk=block(X, firstfamk ,1,nik,NCOV);
vector[nik] lbk=segment(lb, firstfamk ,nik);
vector[nik] ubk=segment(ub, firstfamk ,nik);
vector[nik] lb_indk=segment(lb_ind, firstfamk ,nik);
vector[nik] ub_indk=segment(ub_ind, firstfamk ,nik);
vector[nik] uk=segment(u, firstfamk ,nik);

vector[nik] mu = Xk*betapam;
real XB = XPk*betapam;
real alpha=YPk*log((1-normal_cdf(threshold - XB, 0, 1))/(1-(1-normal_cdf(threshold - XB, 0, 1)))) - log(1/(1-(1-normal_cdf(threshold - XB, 0, 1))));

   vector[nik] z;
     real prob = 0;
      for ( m in 1:nik ) {
        if ( lb_indk[m] == 0 && ub_indk[m] == 0 )  z[m] = inv_Phi(uk[m]);
          else { 
            int km1 = m - 1;
            real v; 
            real z_star;
            real logd;
            row_vector [2] log_ustar = [negative_infinity(), 0];           
            real constrain = mu[m] + ((m > 1) ? Sigmakc[m, 1:km1] * head(z, km1) : 0);
            if ( lb_indk[m] == 1 ) log_ustar[1] = normal_lcdf( ( lbk[m] - constrain ) / Sigmakc[m, m] | 0.0, 1.0 );
            if ( ub_indk[m] == 1 ) log_ustar[2] = normal_lcdf( ( ubk[m] - constrain ) / Sigmakc[m, m] | 0.0, 1.0 );
            logd  = log_diff_exp(log_ustar[2], log_ustar[1]);
            v     = exp( log_sum_exp( log_ustar[1], log(uk[m]) + logd ) );    
            z[m]  = inv_Phi(v);                                          
            prob  += logd;                                                    
          }
        }
          lik += prob-alpha;
}
   return  lik; 
  }
}

data {
int<lower=0> N; 
matrix[N,N] kinship_matrix; 
matrix[N,N] sharedenvironment_matrix_sibs;
matrix[N,N] sharedenvironment_matrix_mother;
matrix[N,N] sharedenvironment_matrix_father;
matrix[N,N] sharedenvironment_matrix_spouses;
matrix[N,N] identity_matrix; 
real threshold; 
vector[N] lb; 
vector[N] ub; 
vector<lower=0,upper=1>[N] lb_ind;
vector<lower=0,upper=1>[N] ub_ind;
int<lower=0> NFAM;
int ni[NFAM];
int firstfam[NFAM];
int<lower=0> NCOV;
matrix[N,NCOV] X;
vector[NCOV] SD;
matrix[NFAM,NCOV] XP;
vector[NFAM] YP;
int<lower=1> fam[NFAM];
int<lower=1> grainsize;
}


parameters {
vector[NCOV] betapam;
real <lower=0, upper= 1> sharedenvironment_sibs;
real <lower=0, upper= fmin(1-sharedenvironment_sibs,sharedenvironment_sibs) > sharedenvironment_mother;
real <lower=0, upper= fmin(1- sharedenvironment_sibs-sharedenvironment_mother, sharedenvironment_sibs)> sharedenvironment_father;
real <lower=0, upper= 1- sharedenvironment_sibs-sharedenvironment_mother-sharedenvironment_father> sharedenvironment_spouses;
real <lower=0, upper= 1-sharedenvironment_sibs-sharedenvironment_mother-sharedenvironment_father-sharedenvironment_spouses> heritability;
vector<lower=0,upper=1>[N] u;
}

transformed parameters{
real <lower=0, upper= 1> individualenvironment = 1-heritability-sharedenvironment_sibs-sharedenvironment_mother-sharedenvironment_father-sharedenvironment_spouses;
}

model {
betapam~ normal(0,10);
heritability~ beta(1,1);
sharedenvironment_sibs~ beta(1,1);
sharedenvironment_mother~ beta(1,1);
sharedenvironment_father~ beta(1,1);
sharedenvironment_spouses~ beta(1,1);
target += reduce_sum(partial_sum,fam , grainsize,X, XP, YP,ni, firstfam, lb, ub, lb_ind, ub_ind, u, NFAM,heritability,sharedenvironment_sibs,sharedenvironment_mother,sharedenvironment_father,sharedenvironment_spouses, individualenvironment, kinship_matrix,sharedenvironment_matrix_sibs,sharedenvironment_matrix_mother,sharedenvironment_matrix_father,sharedenvironment_matrix_spouses,identity_matrix, betapam,NCOV,threshold);

    }
    
generated quantities{
real sigmaSexYearBirth=variance(X*betapam);

//Unstandardized fixed effects
real beta_Sex = betapam[1] / SD[1];
real beta_YearBirth = betapam[2] / SD[2];

//Marginal parameters posterior distributions
real <lower=0, upper= 1> heritability_marginal = heritability/(1+sigmaSexYearBirth);
real <lower=0, upper= 1> sharedenvironment_sibs_marginal = sharedenvironment_sibs/(1+sigmaSexYearBirth);
real <lower=0, upper= 1> sharedenvironment_mother_marginal=sharedenvironment_mother/(1+sigmaSexYearBirth);
real <lower=0, upper= 1> sharedenvironment_father_marginal=sharedenvironment_father/(1+sigmaSexYearBirth);
real <lower=0, upper= 1> sharedenvironment_spouses_marginal=sharedenvironment_spouses/(1+sigmaSexYearBirth);
real <lower=0, upper= 1> sharedenvironment_marginal=sharedenvironment_sibs_marginal + sharedenvironment_mother_marginal + sharedenvironment_father_marginal + sharedenvironment_spouses_marginal;
real <lower=0, upper= 1> individualenvironment_marginal = individualenvironment/(1+sigmaSexYearBirth);
real <lower=0, upper= 1> tauSexYearBirth_marginal = sigmaSexYearBirth/(1+sigmaSexYearBirth);
real <lower=0, upper= 1> tau_Sex_marginal=variance(X[,1]*betapam[1])/(1+sigmaSexYearBirth);
real <lower=0, upper= 1> tau_YearBirth_marginal=variance(X[,2]*betapam[2])/(1+sigmaSexYearBirth);
real doublecovariance_SexYearBirthGroup_marginal=tauSexYearBirth_marginal - tau_Sex_marginal - tau_YearBirth_marginal;
}
